#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

/**
 * n m type delta onAllowed QProb
 * type: how many sticks
 * delta: wnext
 * **/

void putQuery(int v, int u) {
    printf("? %i %i\n", v, u);
}


void putEdge(pair<int, int> e) {
    printf("! %i %i\n", e.first, e.second);
}


void putOn(int v) {
    printf("+ %i\n", v);
}


void putOff(int v) {
    printf("- %i\n", v);
}



int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = atoi(argv[1]);
    int m = atoi(argv[2]);
    if (m < n) {
        m = n + 1;
    }
    vector<int> order(n);
    for (int i = 1; i <= n; i++) {
        order[i - 1] = i;
    }
    shuffle(order.begin() + 1, order.end());
    int type = atoi(argv[3]);
    int delta = atoi(argv[4]);
    int on = atoi(argv[5]);
    int off = 1;
    int ask = atoi(argv[6]);

    vector<pair<int, int>> edges;
    vector<vector<int>> sticks(type, {1});
    vector<int> stInd(n + 1);
    for (int i = 1; i < n; i++) {
        int st = rnd.next(type);
        int ind = rnd.wnext(sticks[st].size(), delta);
        edges.push_back(make_pair(sticks[st][ind], order[i]));
        sticks[st].push_back(order[i]);
        stInd[order[i]] = st;
    }
    printf("%i %i\n", n, m);
    m -= n - 1;
    int ql = -m - 1000;
    sticks.clear();
    sticks.resize(type, {1});
    vector<int> valid = {1}, invalid;

    function<char()> generateQ = [&]() {
        int res = rnd.next(1, on + off + ask);
        if (res <= on && !invalid.empty()) {
            return '+';
        }
        res -= on;
        if (res <= off && !valid.empty()) {
            return '-';
        }
        return '?';
    };

    function<void()> makeAsk = [&]() {
        int s1 = rnd.next(type), s2 = rnd.next(type);
        int v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
        int u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];
        while (v == u) {
            s1 = rnd.next(type);
            s2 = rnd.next(type);
            v = sticks[s1][rnd.wnext(sticks[s1].size(), 100)];
            u = sticks[s2][rnd.wnext(sticks[s2].size(), 100)];
        }
        putQuery(v, u);
    };

    for (auto e : edges) {
        ql++;
        putEdge(e);
        int leaf = e.second;
        sticks[stInd[leaf]].push_back(leaf);
        valid.push_back(leaf);
        for (int i = 0; i < rnd.wnext(m + 1, ql) and m > 0; i++, m--) {
            char c0 = generateQ();
            if (c0 == '?') {
                makeAsk();
            } else if (c0 == '+') {
                int ind = rnd.next(invalid.size());
                swap(invalid[ind], invalid.back());
                putOn(invalid.back());
                valid.push_back(invalid.back());
                invalid.pop_back();
            } else {
                int ind = rnd.next(valid.size());
                swap(valid[ind], valid.back());
                putOff(valid.back());
                invalid.push_back(valid.back());
                valid.pop_back();
            }
        }
    }
    while (m > 0) {
        char c0 = generateQ();
        if (c0 == '?') {
            makeAsk();
        } else if (c0 == '+') {
            int ind = rnd.next(invalid.size());
            swap(invalid[ind], invalid.back());
            putOn(invalid.back());
            valid.push_back(invalid.back());
            invalid.pop_back();
        } else {
            int ind = rnd.next(valid.size());
            swap(valid[ind], valid.back());
            putOff(valid.back());
            invalid.push_back(valid.back());
            valid.pop_back();
        }
        m--;
    }
}