#include "testlib.h"
#include <bits/stdc++.h>

#define ll long long
#define all(x) x.begin(), x.end()
using namespace std;


vector<int> lim = {200000, 1000, 1000, 200000, 200000, 200000};
vector<vector<char>> forbidden = {{}, {'+', '-'}, {}, {'-', '+'}, {'+'}, {}};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().c_str());
    int n = inf.readInt(2, lim[group], "n");
    inf.readSpace();
    int m = inf.readInt(n, lim[group], "m");
    inf.readEoln();
    vector<bool> added(n + 1, false), on(n + 1, true);
    added[1] = true;
    int alive = 1;
    for (int i = 0; i < m; i++) {
        char cmd = inf.readChar();
        ensuref(find(all(forbidden[group]), cmd) == forbidden[group].end(),
                "forbidden action in group %i: %c", group, cmd);
        inf.readSpace();
        if (cmd == '!') {
            int x = inf.readInt(1, n, "parent");
            inf.readSpace();
            int y = inf.readInt(1, n, "child");
            ensuref(!added[y] and added[x], "parent is on tree and leaf is not");
            added[y] = true;
            alive++;
        } else if (cmd == '+') {
            int x = inf.readInt(1, n, "enable");
            ensuref(!on[x], "node must be disabled");
            on[x] = true;
        } else if (cmd == '-') {
            int x = inf.readInt(1, n, "disable");
            ensuref(on[x], "node must be enabled");
            on[x] = false;
        } else if (cmd == '?') {
            int x = inf.readInt(1, n, "v");
            inf.readSpace();
            int y = inf.readInt(1, n, "u");
            ensuref(x != y, "want different nodes");
        }
        inf.readEoln();
    }
    inf.readEof();
    ensuref(alive == n, "must add all nodes");
}
