#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), in = opt<int>("in"), delta = opt<int>("delta");
    double noise = opt<double>("noise"), dr = opt<double>("dr"), dgr = max(1.01, dr);

    int dec9 = 1e9;
    int s = rnd.next(0, dec9 - in - delta), t = s + in;

    println(n, (int) (in - delta * dr), (int) (in + delta * dr));
    auto next_pair = [&]() {
        int ll = rnd.next(0, dec9), rr = rnd.next(0, dec9);
        while (ll == rr) rr = rnd.next(0, dec9);
        if (ll > rr) swap(ll, rr);
        return make_pair(ll, rr);
    };

    for (int i = 0; i < n; i++) {
        if (rnd.next() < noise) {
            auto[l, r] = next_pair();
            println(l, r);
        } else if (i >= n / 20 && i < n - n / 20) {
            println(rnd.next(s - delta, s + delta), rnd.next(t - delta, t + delta));
        } else if (i < n / 20 && noise != 0) {
            println(rnd.wnext(0, s - delta, 2), rnd.wnext(t + delta, dec9, -2));
        } else {
            int ll = rnd.wnext(s + delta, (int) (s + dgr * delta), 2),
                rr = rnd.wnext((int) (t - dgr * delta), t - delta, -2);
            if (ll >= rr) {
                int m = (ll + rr) / 2;
                ll = m - 1, rr = m;
            }
            println(ll, rr);
        }
    }

}