#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), f = opt<int>("from"), t = opt<int>("to");
    int weight = opt<int>("w");

    auto next_pair = [&](int w) {
        int ll = rnd.wnext(f, t, -w), rr = rnd.wnext(f, t, w);
        while (ll == rr) rr = rnd.wnext(f, t, w);
        if (ll > rr) swap(ll, rr);
        return make_pair(ll, rr);
    };

    auto[x, y] = next_pair(weight);
    println(n, x, y);

    vector<pair<int, int>> segs;
    for (int i = 0; i < n; i++) {
        segs.push_back(next_pair(weight / 2));
    }
    std::sort(segs.begin(), segs.end(), [](auto const &p1, auto const &p2) {
        return p1.first < p2.first;
    });
    for (auto &p: segs) {
        println(p.first, p.second);
    }

}